记忆化搜索专题

记忆化搜索前置技能:搜索+动态规划

在信息学中,有两种非常常见的解决问题的方法——搜索和动态规划。搜索的优点在于容易实现,并且如果解决方案存在一定可以找到,但是缺点是它不能很好地处理重叠子问题。动态规划较好地处理了重叠子问题,但是当问题的拓扑关系比较复杂的时候,动态规划也很无奈。记忆化搜索(Memory Search)正是在这种情况下产生的。
记忆化搜索采用的还是搜索的形式,在求解时按照自顶向下的顺序求解,但是每求解一个状态,就将它的解保存下来,在之后遇到重复的状态时,可以不必重新求解。简单来说,就是我们记录一下遇到的每一个状态的值。

例题1:
HDU 1331 Function Run Fun

Problem Description
We all love recursion! Don't we?
Consider a three-parameter recursive function w(a, b, c):
if a <= 0 or b <= 0 or c <= 0, then w(a, b, c) returns:
1
if a > 20 or b > 20 or c > 20, then w(a, b, c) returns:
w(20, 20, 20)
if a < b and b < c, then w(a, b, c) returns:
w(a, b, c-1) + w(a, b-1, c-1) - w(a, b-1, c)
otherwise it returns:
w(a-1, b, c) + w(a-1, b-1, c) + w(a-1, b, c-1) - w(a-1, b-1, c-1)
This is an easy function to implement. The problem is, if implemented directly, for moderate values of a, b and c (for example, a = 15, b = 15, c = 15), the program takes hours to run because of the massive recursion.

Input
The input for your program will be a series of integer triples, one per line, until the end-of-file flag of -1 -1 -1. Using the above technique, you are to calculate w(a, b, c) efficiently and print the result.

Output
Print the value for w(a, b, c) for each triple.

Sample Input
1 1 1
2 2 2
10 4 6
50 50 50
-1 7 18
-1 -1 -1

Sample Output
w(1, 1, 1) = 2
w(2, 2, 2) = 4
w(10, 4, 6) = 523
w(50, 50, 50) = 1048576
w(-1, 7, 18) = 1

题意:
自定义函数w(a, b, c)。
如果 a ≤ 0 或b ≤ 0 或 c ≤ 0, 则返回结果: 1;
如果 a > 20 或 b > 20 或 c > 20, 则返回结果: w(20, 20, 20);
如果 a < b 且 b < c, 则返回结果: w(a, b, c-1) + w(a, b-1, c-1) - w(a, b-1, c)
否则返回结果: w(a-1, b, c) + w(a-1, b-1, c) + w(a-1, b, c-1) - w(a-1, b-1, c-1)

思路:
在这个题目中我们算出了w(x, y, z),那么我们就用一个数组dp[x][y][z]来记录这个函数在参数为x, y, z的时候的值,这样我们下次递归到这里的时候我们可以直接调用这个值而无需递归下去求解。

参考代码:

#include <stdio.h>

int dp[21][21][21] = {0};

int dfs(int a, int b, int c)
{
    if (a <= 0 || b <= 0 || c <= 0)
        return 1;
    if (a > 20 || b > 20 || c > 20)
        return dp[20][20][20];
    if (dp[a][b][c])
        return dp[a][b][c];
    else
    {
        if (a < b && b < c)
            return dp[a][b][c] = dfs(a, b, c - 1) + dfs(a, b - 1, c - 1) - dfs(a, b - 1, c);
        else
            return dp[a][b][c] = dfs(a - 1, b, c) + dfs(a - 1, b - 1, c) + dfs(a - 1, b, c - 1) - dfs(a - 1, b - 1, c - 1);
    }
}

int main()
{
    int a, b, c;
    dp[20][20][20] = dfs(20, 20, 20);
    while (~scanf("%d %d %d", &a, &b, &c) && (a != -1 || b != -1 || c != -1))
    {
        printf("w(%d, %d, %d) = %d\n", a, b, c, dfs(a, b, c));
    }
    return 0;
}

例题2:
POJ 1088 滑雪

Problem Description
Michael喜欢滑雪,这并不奇怪,因为滑雪的确很刺激。可是为了获得速度,滑的区域必须向下倾斜,而且当你滑到坡底,你不得不再次走上坡或者等待升降机来载你。Michael想知道载一个区域中最长底滑坡。区域由一个二维数组给出。数组的每个数字代表点的高度。
下面是一个例子
1 2 3 4 5
16 17 18 19 6
15 24 25 20 7
14 23 22 21 8
13 12 11 10 9
一个人可以从某个点滑向上下左右相邻四个点之一,当且仅当高度减小。在上面的例子中,一条可滑行的滑坡为24-17-16-1。当然25-24-23-...-3-2-1更长。事实上,这是最长的一条。

Input
输入的第一行表示区域的行数R和列数C(1 <= R,C <= 100)。下面是R行,每行有C个整数,代表高度h,0<=h<=10000。

Output
输出最长区域的长度。

Sample Input
5 5
1 2 3 4 5
16 17 18 19 6
15 24 25 20 7
14 23 22 21 8
13 12 11 10 9

Sample Output
25

参考代码:

#include <stdio.h>
#include <algorithm>
using namespace std;
int map[101][101];
int dp[101][101];
int dir[4][2] = {1, 0, 0, -1, -1, 0, 0, 1};
int r, c;

int dfs(int x, int y)
{
    if (dp[x][y])
        return dp[x][y];
    for (int i = 0; i < 4; i++)
    {
        int dx = x + dir[i][0], dy = y + dir[i][1];
        if (dx > 0 && dx <= r && dy > 0 && dy <= c && map[dx][dy] < map[x][y])
        {
            dp[x][y] = max(dfs(dx, dy) + 1, dp[x][y]);
        }
    }
    return dp[x][y];
}

int main()
{
    scanf("%d %d", &r, &c);
    for (int i = 1; i <= r; i++)
    {
        for (int j = 1; j <= c; j++)
        {
            scanf("%d", &map[i][j]);
        }
    }
    int len = 0;
    for (int i = 1; i <= r; i++)
    {
        for (int j = 1; j <= c; j++)
        {
            len = max(dfs(i, j), len);
        }
    }
    printf("%d\n", len + 1);
    return 0;
}

习题:
NITOJ 425 老袁的迷宫

Problem Description
神秘力量对老袁的研究结束了,他们决定放老袁一条生路。现在老袁面对的是一个由n*m个格子组成的迷宫,每个格子上都标有一个数字。老袁需要找到迷宫中最长的一条上升路径,从起点开始,格子上数字一直上升的路径为上升路径。起点可以使迷宫中任意一点只能向上下左右四个方向移动。老袁需要知道最长上升路径的长度,你能帮助他吗?
第一个案例中,最长上升路径为第三行第二列开始的[1,2,6,9]。

Input
测试案例有T组,每组第一行包含两个正整数n,m(1<=n,m<=500),接下来n行,每行包含m个正整数(不大于1000)。

Output
对于每组案例,输出最长上升路径的长度。

Sample Input
2
3 3
9 9 4
6 6 8
2 1 1
3 3
3 4 5
3 2 6
2 2 1

Sample Output
4
4

posted @ 2019-04-30 16:05  redleaves  阅读(579)  评论(0编辑  收藏  举报
Live2D